function e(e, t = {}, n = []) {
    const i = document.createElement(e);
    Object.assign(i, t);
    for (const e of n) i.appendChild(e);
    return i;
  }
  
  function t(t, n = []) {
    return e("div", { className: t }, n);
  }
  
  function n(t, n, i = {}) {
    return e("span", { textContent: n, className: t, ...i });
  }
  
  function i(t, n, i = {}) {
    return e("button", { textContent: n, className: t, ...i });
  }
  
  function r(e) {
    return document.querySelector(e);
  }
  
  function c(c, a) {
    const u = t(
      "redirect-item",
      [
        e("label", { className: "switch" }, [
          e("input", {
            type: "checkbox",
            className: "slider redirect-enabled",
            checked: !!c.enabled,
            onclick: ({ target: e }) => {
              !(function (e, t) {
                const n = x.redirects[e];
                n && ((n.enabled = t), d());
              })(a, e.checked);
            },
          }),
          n("slider"),
        ]),
        n("redirect-name", c.name || v(c)),
        i("redirect-edit", "Edit", {
          onclick: () => {
            !(function (e) {
              const t = x.redirects[e];
              if (!t) return void console.error(`Invalid index: ${e}`);
              (x.editState = h.EDIT),
                (x.editIndex = e),
                r(".title").textContent = "Edit Redirect",
                s(t);
            })(a);
          },
        }),
        i("redirect-delete", "Delete", {
          onclick: () => {
            !(function (e) {
              if (x.redirects.length < e + 1)
                return void console.error(`Invalid redirectIndex: ${e}`);
              x.redirects.splice(e, 1), d(), o();
            })(a);
          },
        }),
      ]
    );
    return (u.dataset.index = a), u;
  }
  
  function d() {
    chrome.storage.local.set({ redirects: x.redirects });
  }
  
  function o() {
    const e = document.querySelector(".redirects-container"),
      { redirects: i } = x;
    (e.innerHTML = ""), (r = []);
    i.length ? (r = i.map(c)) : r.push(t("no-redirects", [n("no-redirects-cta", "Config TC Not Avalaible.")]));
    for (const t of r) e.appendChild(t);
  }
  
  function a() {
    r(".overlay").classList.remove("visible"),
      (x.editState = h.NONE),
      (x.editIndex = -1);
  }
  
  function s(e) {
    (r(".input-name").value = e.name),
      (r(".input-name").placeholder = v(e)),
      (r(".input-from").value = e.from),
      (r(".input-to").value = e.to),
      (r(".input-regexp").checked = !!e.isRegExp),
      r(".overlay").classList.add("visible"),
      r(".input-from").focus();
  }
  
  function u() {
    (x.editState = h.ADD),
      (r(".title").textContent = "New Redirect"),
      s({ name: "", from: "", to: "", isRegExp: !1 });
  }
  
  function l(e) {
    e.preventDefault(),
      r(".input-from").checkValidity() &&
        (x.editState === h.ADD
          ? (function (e) {
              x.redirects.push({ enabled: !0, ...e }), d();
            })(m())
          : x.editState === h.EDIT
          ? (function (e, t) {
              x.redirects.length <= e || (Object.assign(x.redirects[e], t), d());
            })(x.editIndex, m())
          : console.error(`Invalid editState: ${x.editState}`),
        o(x.redirects),
        a());
  }
  
  function p(e) {
    e.preventDefault(), a();
  }
  
  function f() {
    r(".input-name").placeholder = v(m());
  }
  
  function m() {
    return {
      name: r(".input-name").value,
      from: r(".input-from").value,
      to: r(".input-to").value,
      isRegExp: r(".input-regexp").checked,
    };
  }
  
  function v({ from: e, to: t, isRegExp: n }) {
    return n ? `s/${e}/${t}/g` : e ? e + " => " + (t || '""') : "";
  }
  
  async function g() {
    r(".add-redirect").focus(),
      r(".copy-title-all-tabs").addEventListener("click", copyTitleAllTabs),
      r(".add-redirect").addEventListener("click", u),
      r(".popup-ok").addEventListener("click", l),
      r(".popup-cancel").addEventListener("click", p),
      r(".input-from").addEventListener("change", f),
      r(".input-to").addEventListener("change", f),
      r(".input-regexp").addEventListener("change", f),
      (x.redirects = await new Promise((e, t) => {
        chrome.storage.local.get("redirects", t => {
          const n = t.redirects;
          n && n.length && e(n), e([]);
        });
      })),
      o();
  }
  
  const h = { NONE: 0, ADD: 1, EDIT: 2 },
    x = { editIndex: -1, editState: h.NONE, redirects: [] };
  
  function copyTitleAllTabs() {
    chrome.tabs.query({}, function (tabs) {
      const httpTabs = tabs
        .filter(tab => tab.url && (tab.url.startsWith('http://') || tab.url.startsWith('https://')))
        .map(tab => tab.title);
  
      if (httpTabs.length > 0) {
        const allTitles = httpTabs.join('\n');
        copyToClipboard(allTitles);
        alert("Semua Title Tab berhasil disalin!");
      } else {
        alert("Tidak ada tab dengan URL HTTP atau HTTPS yang aktif.");
      }
    });
  }
  
  function copyToClipboard(text) {
    const tempInput = document.createElement("textarea");
    document.body.appendChild(tempInput);
    tempInput.value = text;
    tempInput.select();
    document.execCommand("copy");
    document.body.removeChild(tempInput);
  }
  
  g();
  